//: C06:MemFun2.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Volání členské funkce prostřednictvím reference na objekt.
#include <algorithm>
#include <functional>
#include <iostream>
#include <iterator>
#include <vector>
using namespace std;

class Uhel {
  int stupne;
public:
  Uhel(int stup) : stupne(stup) {}
  int nasob(int krat) { return stupne *= krat; }
};

int main() {
  vector<Uhel> va;
  for(int i = 0; i < 50; i += 10)
    va.push_back(Uhel(i));
  int x[] = { 1, 2, 3, 4, 5 };
  transform(va.begin(), va.end(), x,
    ostream_iterator<int>(cout, " "),
    mem_fun_ref(&Uhel::nasob));
  cout << endl;
  // výstup: 0 20 60 120 200
} ///:~
